/**
 * ExtendedRequest.java
 *
 * File generated from the core::ExtendedRequest uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class ExtendedRequest.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ExtendedRequest", propOrder = {
	"requestName",
	"requestValue"
})
@XmlRootElement(name = "ExtendedRequest")
public class ExtendedRequest extends net.ihe.gazelle.hpd.DsmlMessage implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "requestName", required = true, namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public String requestName;
	@XmlElement(name = "requestValue", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public String requestValue;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return requestName.
	 * @return requestName
	 */
	public String getRequestName() {
	    return requestName;
	}
	
	/**
	 * Set a value to attribute requestName.
	 * @param requestName.
	 */
	public void setRequestName(String requestName) {
	    this.requestName = requestName;
	}
	
	
	
	
	/**
	 * Return requestValue.
	 * @return requestValue
	 */
	public String getRequestValue() {
	    return requestValue;
	}
	
	/**
	 * Set a value to attribute requestValue.
	 * @param requestValue.
	 */
	public void setRequestValue(String requestValue) {
	    this.requestValue = requestValue;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "ExtendedRequest").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(ExtendedRequest extendedRequest, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (extendedRequest != null){
   			net.ihe.gazelle.hpd.DsmlMessage.validateByModule(extendedRequest, _location, cvm, diagnostic);
    	}
    }

}